# Change Log

All notable changes to the Pieces extension will be documented in this file.

## [Released]

### v1.15.1 - Thursday, April 18, 2023

- fix: issue with error reporting

### v1.15.0 - Tuesday, April 16, 2023

- feat: added submenus to the snippet list context menu for creating, updating, and deleting metadata collections
- feat: added right click -> 'modify' feature to have copilot modify some code
- feat: right click on a file and save it
- feat: incrementally render code blocks in copilot, allowing you to highlight and scroll in a code block while it is generating
- fix: only allow one model download at a time
- fix: error handling should be much improved in the copilot
- fix: recommended model buttons in copilot should be in sync with other buttons of the same model
- fix: clicking on model in copilot should be a improved a bit
- fix: sometimes text was unreadable in copilot
- fix: tags should now be fetched and shown properly in the search feature
- fix: a setting was mispelled

### v1.14.1 - Wednesday, March 20, 2023

- fix: fixed an issue with slash commands not working

### v1.14.0 - Tuesday, March 19, 2023

- feat: added the ability to filter snippets on the snippet tree view
- feat: use the visible text as the default context in the 'ask copilot' action (if you have no text selected, it will use the visible text instead)
- feat: ability to drag and drop a snippet into the editor from the snippet tree
- feat: syntax highlight the snippet tooltips
- feat: added websites to custom directives
- feat: show a button to switch to blended processing if you try to OCR an image and have local only processing selected
- feat: added button to conversations to generate a title
- fix: fixed the handling of 'kt' language icon in code blocks
- fix: improved error reporting from the copilot chat, it should now provide an error status and message
- fix: fixed regex issue with adding websites to context
- fix: fixed issue with the pieces: fix action not correctly parsing the broken bit of code
- fix: ensure we don't attach related people with a noreply email
- fix: ensure to disable code lens + code actions on unsupported file types

### v1.13.0 - Tuesday, March 5, 2023

- feat: websites can now be used as context in the copilot
- feat: right click on a snippet to ask copilot about it
- feat: organized the context menu on the snippet tree items
- feat: added ability to view snippets as a flat list (it's now an extension setting)
- feat: local large language model recommendations
- feat: ability to edit user messages in the copilot
- feat: some minor ui enhancements
- feat: metadata enrichment settings to adjust how many tags / websites / etc are generated while saving an asset
- feat: minor reduction in startup times for the copilot
- fix: the main bar display settings should now work (to hide & show the different tabs)

### v1.12.0 - Friday, February 16, 2023

- feat: added accept changes button to copilot code blocks that were generated as a result of using either the comment code lens or quick fix action
- feat: completely revamped onboarding to be an interactive experience powered by a vscode walkthrough
- feat: added support for phi2 local LLMs by microsoft

### v1.11.3 - Monday, January 29, 2023

- fix: minor improvements to crashlytics

### v1.11.2 - Friday, January 26, 2023

- fix: try to launch Pieces OS before prompting user to download and install
- fix: adjust update Pieces OS notification to provide better information as well as not fire unless Pieces OS is below the supported version of the extension
- fix: ensure no more than one Quick fix action per line
- fix: removed the place Copilot prompt in favor of defaulting to the left side panel
- chore: instead of prompting users to email support, send them to the docs support page: docs.pieces.app/support
- chore: add notification in the failure case of trying to launch Pieces OS from a launch button
- fix: the connection error view on Copilot is better on slim screen sizes

### v1.11.1 - Thursday, January 18, 2023

- fix: added button to the 'platform core dependency' notification to not show it again, also adjusted the times at which this notification is shown
- fix: if you click on the refresh button on the snippet list while Pieces OS is not running we will now show an error notification instead of a success notification.

### v1.11.0 - Tuesday, January 16, 2023

- feat: add your own open ai api key
- feat: stop model generation
- feat: enhanced model download %
- feat: gemini model support
- feat: delete downloaded LLM
- fix: code lens should now show up properly
- fix: connecting account no longer results in infinite spinner

### v1.10.0 - Tuesday, December 20, 2023

- feat: added code lens to use Copilot to explain or comment code
- feat: added quick fix action to use Copilot to fix code from the quick fix menu
- feat: added 'Ask Copilot' feature into the terminal context menu
- feat: created submenu for Pieces actions in the editor
- feat: added insert at cursor button into the Copilot code blocks
- feat: added run in terminal button to Copilot code blocks
- feat: changed the Copilot code block buttons to be a bit cleaner
- feat: added message actions to copy, like, dislike, delete, or use a message as context
- feat: added / (slash) commands to the Copilot to perform actions, or perform prompt engineering
- feat: added @ (at) directives to perform as context shortcuts, defaults with 'recent' and 'workspace', can also create custom directives
- feat: adjusted copilot UI to be cleaner and more compact, as well as highlighting the input box
- feat: added ability to OCR an image in the Copilot via pasting into the input or clicking on the image icon
- chore: shortened command descriptions to be concise
- happy holidays! 🎁 🎄

### v1.9.1 - Tuesday, November 21, 2023

- chore: update internal dependencies to support new major Pieces OS version (7.0.0)
- happy thanksgiving!

### v1.9.0 - Tuesday, November 14, 2023

- feat: added new actions to pin, summarize, and view annotations for each conversation
- chore: updates to VS Code Marketplace description

### v1.8.1 - Wednesday, November 8, 2023

- fix: send the selected model id in the request to the qgpt socket

### v1.8.0 - Tuesday, October 31, 2023

- feat: adds persistent copilot conversations, you can now come back to a copilot chat at any time after you leave it
- feat: overhauls the context selector to be much simpler and easier to use
- feat: context is also persisted per conversation, so each conversation will maintain its context indefinitely
- feat: snippets can now be used as context
- feat: you can now right click on a file, folder, or snippet and add it to the current conversation's context
- feat: happy halloween!

### v1.7.0 - Friday, October 13, 2023

- fix: fixed an issue where filepaths that were used as context for the copilot became stale due to a rename or delete
- fix: make sure we don't rerender too many times while editing a snippet in the extension, because we are now streaming asset changes from Pieces OS.
- fix: if a model id becomes stale, make sure to unstale it
- feat: when a snippet is saved from the editor, the opened file's path will be attached as an anchor
- feat: when a snippet is saved from copilot, the top 3 relevant file paths will be attached as anchors.

### v1.6.0 - Friday, October 6, 2023

- feat: added support for new PaLM 2 LLM's, Chat Bison and Code Chat Bison
- feat: added line numbers to Copilot chat code blocks
- feat: added language header to Copilot chat code blocks
- feat: added a setting to not autoclose the snippet editor on save (default is to not close it)
- fix: changed the default autocomplete key to 'tab only', preventing writing to settings.json without user interaction
- fix: snippet similarity detection in copilot is working now
- feat: the context selector now has an empty state (if there is no workspace folder open)
- feat: adjusted some of the expand icons

### v1.5.0 - Tuesday, October 3, 2023

- feat: Copilot webview is now more themeable
- feat: added quick action buttons to the copilot empty state to select context, and LLM runtime
- feat: automatic updating to the snippet trees via websocket
- feat: new sections on the readme for the Copilot

### v1.4.0 - Thursday, September 21, 2023

- feat: New Copilot LLM runtimes, you can now choose between multiple different models, including Llama2 models which run solely on your own machine!
- fix: context loader should be resolving paths a bit better now
- fix: don't throw a bunch of unhandled exceptions if Pieces OS is not open

### v1.3.2 - Saturday, September 16, 2023

- fix: if pieces os is closed, and then opened, ensure the copilot socket has a connection before sending the user's input.

### v1.3.1 - Saturday, September 16, 2023

- fix: change the minimum required version to 6.1.0 instead of 6.2.0

### v1.3.0 - Friday, September 15, 2023

- feat: right click on a file, folder, or workspace, and ask Pieces Copilot about it
- feat: stream Pieces Copilot responses, showing the message as it generates instead of all at once after it is done. (much faster response times!)

### v1.2.1 - Friday, September 8, 2023

- fix: improve the styling of the copilot webview, increasing the amount of conversation that shows on the screen, and fixing the alignment of some buttons
- fix: default context to no files in order to reduce load on Pieces OS, use snippets as context instead.

### v1.2.0 - Tuesday, September 5, 2023

- feat: add context selection into Copilot, configure which files in your workspace the Copilot uses as context.
- feat: enhances the right click -> ask copilot about selection feature to maintain the selection as the relevant context for further chat messages.

### v1.1.1 - Friday, August 25, 2023

- feat: added a command to open up the Pieces Copilot titled 'Open Pieces Copilot'.
- feat: utilize more pointed context during the right click -> ask Pieces Copilot about selection feature.
- fix: prevent crash while using the above mentioned feature in an unsupported file extension i.e .yml.

### v1.1.0 - Wednesday, August 23, 2023

- feat: includes pieces copilot ai assistant to the extension, utilize RAG to gain insight on your workspace.
- fix: Only proactively Launch PiecesOS when you attempt to "save to Pieces".(launch PiecesOS will still be in notifications as well as within the settings menu, enabling us to still launch the application.)

### v1.0.1 - Monday, August 21, 2023

- Minimum updates required for PiecesOS 6.0.0 support.
- bumped minimum PiecesOS version required to 6.0.0

### v1.0.0 - Monday, July 17, 2023

- This version is a rewrite that includes fixes and performance & stability improvements

### v0.6.4 - Thursday, June 27, 2023

- updated search command shortcut to ctrl+alt+p/cmd+alt+p to avoid keybinding conflicts. The shortcut can also be changed in VSC settings

### v0.6.3 - Thursday, June 25, 2023

- updated search command shortcut back to the original shortcut: (Mac: cmd+k) (Windows: ctrl+k). Known issue Macos shortcut has a shortcut conflict. We will be revisiting these shortcuts in the coming week.

### v0.6.2 - Thursday, June 25, 2023

- updated search command shortcut to (Mac: cmd+shift+k) (Windows: ctrl+shift+k)

### v0.6.1 - Thursday, June 1, 2023

- updated SDK for Pieces OS 5.0.0 support

### v0.6.0 - Tuesday, March 7, 2023

- New related materials view.
- Side Panel Views settings for displaying the different tree views.
- Bug Fixes, Stability & Performance Improvements.

### v0.5.0 - Wednesday, March 1, 2023

- New explored materials & snippet insights view.
- Bug Fixes, Stability & Performance Improvements.

### v0.4.0 - Thursday, February 09, 2023

- New suggested materials view.
- Bug Fixes, Stability & Performance Improvements.

### v0.3.0 - Tuesday, January 31, 2023

- Added ability to add multiple tags and links using comma.
- Sign-in button added for generating shareable link while logged out.
- View shareable link within markdown preview.
- Reactive markdown preview when editing snippet and/or metadata.
- Bug Fixes, Stability & Performance Improvements.

### v0.2.1 - Monday, January 23, 2023

- Minor change to marketplace page.

### v0.2.0 - Friday, January 20, 2023

- New Global Search Settings & Display Preferences.
- Improved Notification Messages.
- Redesigned Marketplace Page.
- Bug Fixes, Stability & Performance Improvements.

### v0.1.21 - Wednesday, December 21, 2022

- General performance enhancements and bug fixes.

### v0.1.20 - Wednesday, December 14, 2022

- Added image support: edit image ocr and preview image ocr in markdown.
- General performance enhancements and bug fixes.

### v0.1.19 - Tuesday, December 08, 2022

- Version check for Pieces OS.
- Improved file names for edit and preview.
- General performance enhancements and bug fixes.

### v0.1.18 - Tuesday, November 22, 2022

- Added support for linux.
- Supports at least 3.0.0 Pieces OS.
- Removed default value for autocomplete key.

### v0.1.17 - Friday, October 21, 2022

- Using Git information to add related people, related links, and commit messages to the saved snippet.
- New About webview.
- Autocomplete disabled by default in settings.

### v0.1.16 - Friday, September 30, 2022

- Updated the preview for viewing snippets. Now a table is displayed with description, tags, language, people, sensitives, and website links along with code/image.
- Added support for JSON, YAML, and TOML snippets.
- General performance enhancements and bug fixes.

### v0.1.15 - Friday, September 07, 2022

- Updated onboarding notifications.
- General performance enhancements and bug fixes.
- Updated marketplace description.
- Changed the default display to Preview.

### v0.1.14 - Friday, July 22, 2022

- Users can now select if they want to only see critical notifications or all notifications.
- Users can select the key for autocomplete in settings.
- Updated marketplace description.

### v0.1.13 - Wednesday, June 22, 2022

- Temporarily disables Sentry.

### v0.1.12 - Friday, June 10, 2022

- Updated marketplace description.

### v0.1.11 - Thursday, June 9, 2022

- Updated UI for sign in and connect to pieces cloud.
- Users can now share snippets via link. Right-click on the snippet in Tree View and select “Share via Pieces Link”.
- Users can now share selected code via link. Just highlight your code, right-click and select “Share via Pieces Link”.

### v0.1.10 - Thursday, May 26, 2022

- Pieces will now auto-save snippets for you based on reuse patterns
- Users can now search and insert snippets in the text editor using right click or keyboard shortcut (Mac: cmd+k) (Windows: ctrl+k)

### v0.1.9 - Thursday, May 19, 2022

- Temporarily disables auto-save feature

### v0.1.8 - Tuesday, May 17, 2022

- Users can now edit snippets within VS Code by right clicking on a snippet and clicking edit
- Users now have an option to view their snippets by name, description, or preview
- Users can now add their VS Code User Snippets to Pieces by going into Pieces Settings and clicking "Add User Snippets to Pieces"
- Updated onboarding
- Option to enable/disable auto saving in settings

### v0.1.7 - Thursday, April 28, 2022

- Users can now add tags and related links to their snippets within VS Code
- Users can now sign in and out of Pieces OS via the plugin settings
- Smarter Tree View that will auto-expand based on the open file extension
- Auto saving of snippets based on user copy and paste patterns
- Updated error and success notifications

### v0.1.6 - Friday, April 1, 2022

- Updated Marketplace Listing

### v0.1.5 - Friday, March 25, 2022

- Autocomplete Setting - users can now Enable/Disable autocomplete in the Pieces Extension settings menu.

### v0.1.4 - Thursday, March 24, 2022

- Autocomplete - users can now autocomplete a Piece from their saved Pieces.

### v0.1.3 - Wednesday, March 23, 2022

- Reclassify - users can now reclassify snippet languages through the extension.

### v0.1.2 - Wednesday, March 23, 2022

- Fixed the empty state in the Pieces Explorer
- Updated IDs of activity bar registration identifier to eliminate concern of conflicts with other extensions

### v0.1.1 - Tuesday, March 22, 2022

- Onboarding - upon install, users are now redirected to a webpage to make sure they have all pre-reqs to get started with Pieces
- Troubleshooting - when a user does not have Pieces OS installed or launched, Pieces will guide them on taking necessary actions
- Delete a Piece - when you right click on a snippet in the Saved Pieces View you can now delete it from the view.

### v0.1.0 - Thursday, Feb 10, 2022

- Updates to README.md
- Users can rename their snippet
- Insert to preview and read-only pop up alert
- Auto refresh TreeView when saving in VSCode
- Incremental fetching

### v0.0.8 - Friday, Jan 14, 2022

- Updates to README.md
- Changed the Pieces display name

### v0.0.7 - Friday, Jan 14, 2022

- Updated image links for the Marketplace

### v0.0.6 - Thursday, Jan 13, 2022

- Updates to README.md
- Updates to the Marketplace description

### v0.0.5 - Wednesday, Jan 12, 2022

- Added a list view to view saved snippets within VSCode
- Users can now view saved images
- General performance enhancements and bug fixes

### v0.0.4 - Thursday, Sept 2, 2021

- Updated README.md

### v0.0.3 - Thursday, Sept 2, 2021

- Updated keyboard shortcut from [Ctrl+Shift+P] to [Ctrl+Shift+V]
- Updated README.md

### v0.0.2 - Wednesday, Sept 1, 2021

- Updated README.md

### v0.0.1 - Wednesday, Sept 1, 2021

- Initial release
- Checks to make sure code is selected
- Proper error & success notifications
- Quickly save code in Pieces without disrupting your flow
