/* eslint-disable no-undef */
// eslint-disable-next-line @typescript-eslint/no-var-requires
const esbuild = require('esbuild');

const prod = process.argv[2] === 'production';

const configs = [
  {
    target: 'node18',
    entryPoints: ['./src/extension.ts'],
    outfile: './dist/extension.js',
    logLevel: 'info',
    treeShaking: true,
    bundle: true,
    platform: 'node',
    sourcemap: prod ? false : 'inline',
    external: ['vscode'],
    resolveExtensions: ['.ts', '.js'],
    loader: {
      '.ts': 'ts',
    },
    minify: prod,
  },
  {
    target: 'chrome114',
    entryPoints: ['./src/ui/views/WebViews/copilot/index.ts'],
    outfile: './dist/gptView.js',
    logLevel: 'info',
    treeShaking: true,
    bundle: true,
    platform: 'browser',
    sourcemap: !prod,
    loader: {
      '.ts': 'ts',
      '.png': 'dataurl',
      '.svg': 'text',
    },
    resolveExtensions: ['.ts', '.js'],
    minify: prod,
  },
];

(async () => {
  let i = 0;
  for (const config of configs) {
    const context = await esbuild.context(config);
    if (prod) {
      await context.rebuild();
      i++;
      if (i == configs.length) process.exit(0);
    } else {
      await context.watch();
    }
  }
})();
