## The Pieces Copilot is an AI-enabled assistant designed to solve complex problems through a contextual understanding of your unique workflow.

Use the copilot to ask questions about entire repositories, debug and review code, explain a concept, or just talk through ideas.

### **Ask Copilot**

Ask the Copilot about a file, folder, snippet, code fragment, or terminal output. All available by right clicking, and then selecting 'Ask Copilot'

![Ask Copilot](https://storage.googleapis.com/pieces_multimedia/PROMOTIONAL/PIECES_FOR_DEVELOPERS/VS_CODE/MACOS/COPILOT/16X9/PIECES_FOR_DEVELOPERS-VS_CODE-ASK_COPILOT-MACOS-16X9-1_31_2024.gif)

### **Chat with any of your materials, anywhere**

Set files, folders, and snippets as context in order to ask Copilot about them.

![Context management](https://storage.googleapis.com/pieces_multimedia/PROMOTIONAL/PIECES_FOR_DEVELOPERS/VS_CODE/MACOS/COPILOT_CONTEXT_GENERIC/16X9/PIECES_FOR_DEVELOPERS-VS_CODE-COPILOT_CONTEXT_GENERIC-MACOS-16X9-1_31_2024.GIF)

### **Leverage your choice of local, cloud, and even custom LLMs for secure, customized assistance.**

Choose from our extension list of LLMs including GPT 4, Llama 2, and Mistral.

![LLM Runtimes](https://storage.googleapis.com/pieces_multimedia/PROMOTIONAL/PIECES_FOR_DEVELOPERS/VS_CODE/MACOS/COPILOT/16X9/PIECES_FOR_DEVELOPERS-VS_CODE-COPILOT-MACOS-16X9-1_31_2024.GIF.gif)

### **Effortlessly fix your errors**

Integrated into the VS Code quick fix menu, when you have an error in your code, simply open the quick fix menu and select 'Pieces: Fix' to have the Copilot resolve your issue for you.

![Pieces: Fix](https://storage.googleapis.com/pieces_multimedia/PROMOTIONAL/PIECES_FOR_DEVELOPERS/VS_CODE/MACOS/ANY_FEATURE/16X9/VS-CODE-PIECES-FIX.gif)

### **Generate comments and explanations for your code**

Each method in your code has a code lens (like git lens) that allows you to explain, or comment your code.

![Pieces: Comment and Pieces: Explain](https://storage.googleapis.com/pieces_multimedia/PROMOTIONAL/PIECES_FOR_DEVELOPERS/VS_CODE/MACOS/ANY_FEATURE/16X9/PIECES_FOR_DEVELOPERS-VS_CODE-COMMENT-MACOS-16X9-9_6_2023.gif)

### **Extract code from images**

Extract code from a screenshot either by pasting it into the Copilot input, or by clicking on the image icon in the input box.

![OCR](https://storage.googleapis.com/pieces_multimedia/PROMOTIONAL/PIECES_FOR_DEVELOPERS/VS_CODE/MACOS/COPILOT_OCR/16X9/PIECES_FOR_DEVELOPERS-VS_CODE-COPILOT_OCR-MACOS-16X9-1_31_2024.GIF.gif)

### **Utilize directives to quickly reuse materials as context**

Simply type @ into the input box to see your list of directives, or create a custom one.

![Directives](https://storage.googleapis.com/pieces_multimedia/PROMOTIONAL/PIECES_FOR_DEVELOPERS/VS_CODE/MACOS/ANY_FEATURE/16X9/PIECES_FOR_DEVELOPERS-VS_CODE-DIRECTIVES-MACOS-16X9-1_31_2024.GIF.gif)

### **Perform quick actions with slash commands**

Quickly find related people, save snippets, comment code, and more by using a `/` command in the input box.

![Slash Commands](https://storage.googleapis.com/pieces_multimedia/PROMOTIONAL/PIECES_FOR_DEVELOPERS/VS_CODE/MACOS/COPILOT/16X9/PIECES_FOR_DEVELOPERS-VS_CODE-SLASH_COMMANDS-MACOS-16X9-1_31_2024.GIF.gif)

### **Go back to your past conversations at any time**

Searchable persistent conversations allow you to go back and see all your past interactions with the Copilot, synced across all our integrations. See your conversations from the desktop app, your IDE, and your browser - anywhere you’ve installed Pieces.

![Persistent Chats](https://storage.googleapis.com/pieces_multimedia/PROMOTIONAL/PIECES_FOR_DEVELOPERS/VS_CODE/MACOS/COPILOT/16X9/PIECES_FOR_DEVELOPERS-VS_CODE-PERSISTED_CHATS-MACOS-16X9-1_31_2024.GIF.gif)

### **Personalized suggested prompts based on your conversation and saved materials**

Get started faster with personalized suggested prompts based on your conversation and saved materials.

![Suggested Prompts](https://storage.googleapis.com/pieces_multimedia/PROMOTIONAL/PIECES_FOR_DEVELOPERS/VS_CODE/MACOS/SUGGESTED_MATERIALS/16X9/PIECES_FOR_DEVELOPERS-VS_CODE-SUGGESTED_MATERIALS-MACOS-16X9-1_31_2024.GIF.gif)

### **Quickly link back to relevant files**

If the Copilot used a file as relevant context, it will show it in the chat window, and you can click on it to view it.

![Relevant Files](https://storage.googleapis.com/pieces_multimedia/PROMOTIONAL/PIECES_FOR_DEVELOPERS/VS_CODE/MACOS/COPILOT_CONTEXT_FILES/16X9/PIECES_FOR_DEVELOPERS-VS_CODE-RELATED_FILES-MACOS-16X9-1_31_2024.GIF.gif)
