const fs = require('fs');
const path = require('path');

// Grabbing package.json values
const packageJson = require('../package.json');

// Might not want to do this
packageJson.preview = false;

// Setting beta package name
packageJson.name = 'pieces-vscode-beta';

// Setting beta display name
packageJson.displayName = `${packageJson.displayName} (BETA)`;

// Setting beta description
packageJson.description = `BETA Version of Pieces for Visual Studio Code. ${packageJson.description}`;

// Setting beta icon
packageJson.icon = 'icon/pieces_logo_black_256.png';

console.log(packageJson.version);

// Writing all these values to package.json
fs.writeFileSync(
  path.join(path.resolve('.'), 'package.json'),
  JSON.stringify(packageJson, null, 2)
);

// Copying README.beta.md to README.md
let readme = fs.readFileSync(path.join(__dirname, '../readme.beta.md'), 'utf8');
fs.writeFileSync(path.join(__dirname, '../readme.md'), readme);
